package Session;

import java.util.*;
import java.lang.reflect.*;
import java.io.*;

/**
** <code>Cache</code> is a user-defined class.
*/
public class Cache
{
    private static Cache _instance=null;
    private static char[] data=null;
    private final int MAX_LEN = 512000; // 512 K

    public static Cache getInstance()
    {
        if(_instance==null)
            _instance = new Cache();
        return _instance;
    }

    private Cache()
    {
        init();
        System.out.println("In constructor of Session::Cache");
    }

    private synchronized void init()
    {
        // Initializing the member variable(s)
        data = new char[MAX_LEN];
        for(int i=0; i<MAX_LEN; i++)
            data[i]=(i%2==0)?'0':'1';
    }
    
    public char[] getData(int len)
    {
        // {{ Basic Validation
        if(len<0)
            len=0;
        else if(len>MAX_LEN)
            len=MAX_LEN;
        // }}

        char ret[] = new char[len];
        if(0==len)
            return ret;

        java.lang.System.arraycopy(data, 0, ret, 0, len); // copy cache to the return array

        // {{ Timestamp at the end
        String time = Calendar.getInstance().getTime().toString();
        for(int i=ret.length,j=time.length(); i>0 && j>0; i--,j--)
            ret[i-1]=time.charAt(j-1);
        // }}

        return ret;
    }
/*    
    public static void main(String args[])
    {
        Cache c1 = Cache.getInstance();
        Cache c2 = Cache.getInstance();
        Cache c3 = Cache.getInstance();
        System.out.println("c1::-2 chars='" + new String(c1.getData(-2)) + "'");
        System.out.println("c1::0 chars='" + new String(c1.getData(0)) + "'");
        System.out.println("c1::2 chars='" + new String(c1.getData(2)) + "'");
        System.out.println("c2::5 chars='" + new String(c1.getData(5)) + "'");
        System.out.println("c2::15 chars='" + new String(c1.getData(15)) + "'");
        System.out.println("c3::25 chars='" + new String(c1.getData(25)) + "'");
        System.out.println("c3::50 chars='" + new String(c1.getData(50)) + "'");
    }
*/
}
